/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




#include <drawer.hpp>

#include <image.hpp>
#include <image_zbuffer.hpp>
#include <pos2.hpp>
#include <line_discrete.hpp>
#include <line_discrete_algorithm.hpp>
#include <triangle_scanline.hpp>

#include <iostream>




namespace cpe
{




    //affiche une ligne de couleur uniforme
    void draw_line(image& im,const pos2& u0,const pos2& u1,const color& c)
    {

        // ********************************************* //
        // ********************************************* //
        // [TO DO] : AFFICHAGE D'UNE LIGNE
        //
        // Algorithm:
        //
        //   Calculer coordonnees entre (u0,u1)
        //   Pour toutes coordoonnees u=(x,y)
        //       Si u est dans l'image (im.check_position(u)==true)
        //           affecter couleur a l'image en position u (im(u)=c)
        //
        // ********************************************* //
        // ********************************************* //


        // ********************************************* //
        // Code intermediaire (affiche 2 points): a enlever et remplacer par l'algorithme reel
        if(im.check_position(u0)==true) im(u0)=c;
        if(im.check_position(u1)==true) im(u1)=c;
        // ********************************************* //


    }




    void draw_triangle(image& im,const pos2& u0,const pos2& u1,const pos2& u2,const color& c)
    {
        // ********************************************* //
        // ********************************************* //
        // [TO DO] : AFFICHAGE D'UN TRIANGLE
        //
        // Algorithm:
        //
        //   Construit triangle_scanline a partir de (u0,u1,u2)
        //   Pour tout les pointeurs de triangle_scanline
        //       p_begin <- pointeur premiere position (y_min)
        //       p_end   <- pointeur derniere position (y_max)
        //
        //       Recuperer coordonnees (u_begin,u_end) pointees par p_begin,p_end
        //
        //       Calculer ligne discrete entre (u_begin,u_end)
        //       Afficher ligne
        //
        // ********************************************* //
        // ********************************************* //

        //debut de l'algorithme:
        //   Construit triangle_scanline a partir de (u0,u1,u2)
        triangle_scanline triangle(u0,u1,u2);
        for(int index=0;index<triangle.size();++index)
        {
            //   Pour tout les pointeurs de triangle_scanline
            //       p_begin <- pointeur premiere position (y_min)
            //       p_end   <- pointeur derniere position (y_max)
            const line_pointer& p_begin=triangle.first_point[index];
            const line_pointer& p_end=triangle.last_point[index];

            //       Recuperer coordonnees (u_begin,u_end) pointees par p_begin,p_end
            // .... A COMPLETER A PARTIR D'ICI ....
            // u_begin=triangle.get_coordinate(p_begin) ...
        }
    }




}
