/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



#ifndef DRAWER_HPP
#define DRAWER_HPP

#include <color.hpp>

namespace cpe
{

class image;
class image_zbuffer;
class pos2;



// ********************************************* //
// ********************************************* //
//  DRAWING FUNCTIONS
// ********************************************* //
// ********************************************* //

/** \brief draw line on image with uniform color */
void draw_line(image& im,const pos2& u0,const pos2& u1,const color& c=color(1,0,0));

/** \brief draw triangle with uniform color */
void draw_triangle(image& im,const pos2& u0,const pos2& u1,const pos2& u2,const color& c=color(1,0,0));


}





#endif
