/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




#include <image_zbuffer.hpp>

#include <sstream>
#include <fstream>
#include <color.hpp>
#include <pos2.hpp>
#include <image_io.hpp>

namespace cpe
{

  
    image_zbuffer::image_zbuffer()
        :image()
    {}

    image_zbuffer::image_zbuffer(int N)
        :image(N,N),internal_z_buffer(N,N)
    {
    }

    image_zbuffer::image_zbuffer(int Nx_param,int Ny_param)
        :image(Nx_param,Ny_param),internal_z_buffer(Nx_param,Ny_param)
    {
    }



    double image_zbuffer::z(const pos2& index) const
    {
        assert_position(index);
        return internal_z_buffer(index);
    }
    double& image_zbuffer::z(const pos2& index)
    {
        assert_position(index);
        return internal_z_buffer(index);
    }

    void image_zbuffer::export_z_buffer(const std::string& filename) const
    {
        if(filename.find(".ppm")!=std::string::npos)
            export_ppm(filename,internal_z_buffer);
    }

}
