
#include <render_engine.hpp>

#include <vec3.hpp>
#include <drawer.hpp>
#include <pos2.hpp>
#include <image_zbuffer.hpp>
#include <mesh.hpp>
#include <image_zbuffer.hpp>

namespace cpe
{


render_engine::render_engine(image_zbuffer& im,const scene& scene_parameter,const shading& shading_parameter)
    :internal_image(im),internal_scene(scene_parameter),internal_shading(shading_parameter)
{
}


void render_engine::render(const vertex& v0,const vertex& v1,const vertex& v2)
{
    // ********************************************* //
    // ********************************************* //
    // [TO DO]: Afficher triangle
    //
    //  Algorithme:
    //
    //     Projeter 3 coordonnees des sommets (internal_scene.matrice_projection*coordonnee)
    //     Convertir coordonnees reelles en valeur de pixel (real_coordinate_to_image_coordinate)
    //     Calculer couleurs issuent du shading pour les 3 sommets
    //     Afficher triangle
    //
    // ********************************************* //
    // ********************************************* //

}

void render_engine::render(const mesh& m)
{
    //Affichage du maillage au complet
    for(int k=0,N=m.number_of_triangle();k<N;k++)
    {
        int k0=m.connectivity(3*k+0);
        int k1=m.connectivity(3*k+1);
        int k2=m.connectivity(3*k+2);

        vertex v0(m.vertex(k0),m.normal(k0),m.color(k0));
        vertex v1(m.vertex(k1),m.normal(k1),m.color(k1));
        vertex v2(m.vertex(k2),m.normal(k2),m.color(k2));

        render(v0,v1,v2);
    }
}




pos2 real_coordinate_to_image_coordinate(const vec3& p,int Nx,int Ny)
{
    pos2 u=pos2(Nx+(p.x()-1.0)/(2.0)*Nx,Ny+(p.y()-1.0)/(2.0)*Ny);
    return u;
}

}
