/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SCENE_HPP
#define SCENE_HPP

#include <matrix4.hpp>
#include <vec3.hpp>

namespace cpe
{

/** \brief A 3D scene containing a projection matrix and a light */
struct scene
{
    scene(const matrix4& matrix_projection_param=matrix4::projection_perspective(45,1.0,0.1,10),const vec3& light_param=vec3(2,-2,5));


    matrix4 matrix_projection;
    vec3 light;
};

}

#endif
