/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <shading.hpp>

#include <cmath>


namespace cpe
{
shading::shading(float ambiant_,float diffuse_,float specular_,float specular_exponent_)
    :ambiant(ambiant_),diffuse(diffuse_),specular(specular_),specular_exponent(specular_exponent_)
{}

color apply_shading(const vertex& v,const scene& scene3d,const shading& shad)
{
    return apply_shading(v.p,v.n,v.c,scene3d,shad);
}

color apply_shading(const vec3& p,const vec3& n,const color& c,const scene& scene3d,const shading& shad)
{

    // ********************************************* //
    // ********************************************* //
    //  [TO DO] Calcul d'illumination pour un sommet 3D + normal + couleur original
    //
    // ALGORITHME:
    //
    // c0 <- couleur initiale
    // d <- vecteur unitaire pointant vers la source lumineuse
    // t <- vecteur unitaire pointant vers la camera (camera en (0,0,0))
    // s <- symétrique de t par rapport à la normale
    //
    // c_ambiant = ambiant * c0
    // c_diffus  = cos^n(normal,d) * c0;
    // c_specular= cos^m(s,d)
    //
    // c = c_ambiant + c_diffus + c_specular
    //
    // ********************************************* //
    // ********************************************* //


    return c;
}


}
