
/** TP 4ETI - CPE Lyon - 2012-2013 */

#include <iostream>
#include <cstdlib>



#include <render_engine.hpp>
#include <color.hpp>
#include <image.hpp>
#include <drawer.hpp>
#include <image_zbuffer.hpp>
#include <line_discrete_algorithm.hpp>
#include <line_discrete.hpp>
#include <triangle_scanline.hpp>

#include <mesh.hpp>


using namespace cpe;

int main(int argc,char *argv[])
{
    std::cout<<"****"<<std::endl;
    std::cout<<"run "<<argv[0]<<" with "<<argc-1<<" parameters ... \n"<<std::endl;

    try //rappel: try=recuperation d'exception en cas de probleme
    {

        //une image
        image im(20);

        //remplissage de l'image en blanc
        im.fill(color(1,1,1));


        //pixel (5,4) en vert
        im(pos2(15,14))=color(0,1,0);

        for(int k=0;k<9;++k)
        {
            pos2 u(k+3,3); //position variant suivant x
            color c(k/8.0,0,0); //couleur variant de noir à rouge
            im(u)=c; //ecriture de la couleur dans l'image
        }


        //sauve l'image dans un fichier
        std::cout<<"Draw picture on disk ..."<<std::endl;
        im.export_file("my_pic.ppm");
        std::cout<<"[OK]"<<std::endl;
    }
    catch(exception_cpe e) //affichage d'information si une exception arrive
    {
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"Exception found"<<std::endl;
        std::cout<<e.info()<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        exit(1);
    }

    std::cout<<"Exit Main"<<std::endl;
    return 0;
}
